﻿#Donwload the SQLPSX Module
#http://sqlpsx.codeplex.com/
#Import-module SQLSERVER
#Import-module Functions
#Thanks to Sir Allen White 

#Region Troubleshooting_1_PerfCounters

#Desktop Win7 R2D2 is my Repository

#Todas as categorias de contadores
#All Categorys and Counters LOCAL MACHINE 
Get-PerfCounterCategory | Sort-Object Category_Name

#Ver os Contadores de Performance do SQL Server Localmente
#See the SQL Server Performance Counters locally
Get-PerfCounterCategory -CategoryName "SQLServer*" | `
Sort-Object Category_name | Format-list Machine_Name,Category_Name,Category_Type,Category_Description

#Ver os Contadores de Performance do SQL Server Remoto
#Get the SQL Server Counters on  QuiGonJinn
Get-PerfCounterCategory -CategoryName "SQLServer*" -ComputerName QuiGonJinn | `
Sort-Object Category_name | Format-list Machine_Name,Category_Name,Category_Type,Category_Description


#To setup de xml file
https://www.simple-talk.com/sql/database-administration/gathering-perfmon-data-with-powershell/


#Tudo Configurado, começar a Coleta -Slavando em TXT Somente
#OK ALl Done, lets Start Gathering outputing only to TXT.
#Notice that the function uses -runasjob, or it is done to all servers in parallel using  background jobs
Set-CollectPerfCounter 	-DateTimeStart "2013/01/01 08:00:00" `
						-DateTimeEnd  "2013/12/31 23:00:00" `
						-Interval 1 `
						-PathConfigFile "C:\SQLBITS\PerformanceCounters\PerformanceCounters_ObiWan.XML" `
						-PathOutputFile "C:\SQLBITS\PerformanceCounters\PerformanceCounter.txt" `
						-runasjob 


#Tudo Configurado, começar a Coleta -Salvando em Tabela com Nome da Tabela gerado pelo posh
#Ok. Now Lets Save to A SQL Server Table. The Table Name is generated by the Posh Module
Set-CollectPerfCounter 	-DateTimeStart "2013/01/01 08:00:00" `
						-DateTimeEnd  "2013/12/31 23:00:00" `
						-Interval 1 `
						-PathConfigFile "C:\SQLBITS\PerformanceCounters\PerformanceCounters_ObiWan.XML" `
						-PathOutputFile "C:\SQLBITS\PerformanceCounters\PerformanceCounter.txt" `
						-ServerName "R2D2" `
						-DatabaseName "SQLServerRepository" `
						-NewTable 	-RunAsJob

#Drop The Tables
#Tudo Configurado, começar a Coleta -Salvando em Tabela com Meu Nome da tabela 
#Now lets do it with a named TableName
Set-CollectPerfCounter 	-DateTimeStart "2013/01/01 08:00:00" `
						-DateTimeEnd  "2013/12/31 23:00:00" `
						-Interval 1 `
						-PathConfigFile "C:\SQLBITS\PerformanceCounters\PerformanceCounters_ObiWan.XML" `
						-PathOutputFile "C:\SQLBITS\PerformanceCounters\PerformanceCounter.txt" `
						-ServerName "R2D2" `
						-DatabaseName "SQLServerRepository" `
						-NewTable `
						-tablename "PerfCounters" `
						-RunAsJob

#verificar se esta rodando
#Is it running ?
Get-Job 

#parar todas as coletas 
#Stop All gathering
Get-Job | Remove-Job -Force

#Drop Tables
#Coletar Todos os Servidores - Agora a coisa fica legal  Nome output geral 
#Now it is COOOOL !!! Lets Gathering ALL SERVERS. To All XML created

dir "C:\sqlbits\PerformanceCounters\*.Xml" | `
Set-CollectPerfCounter 	-DateTimeStart "2013/01/01 08:00:00" `
						-DateTimeEnd  "2013/12/31 23:00:00" `
						-Interval 1 `
						-PathOutputFile "C:\sqlbits\PerformanceCounters\PerformanceCounter.txt" `
						-ServerName "R2D2" `
						-DatabaseName "SQLServerRepository" `
						-TableName "PerfCounters" `
						-NewTable 	-RunAsJob		
						
						
#The CODE
#Array to Store the XLXS created
$XLSnames = @()
#forach in the servers
Get-Content "C:\SQLBITS\Servers.txt" | foreach {
	
	$ServerName = $_
	
	#query to get all information
	$Query = "
	with CTEPerfCounters_$($ServerName) ([date] ,[Buffer cache hit ratio],[%_Processor_Time],[PLE])
	as
	(
		select	substring(convert(varchar(10),[datetime],111),1,10) as Date,
				avg([$($ServerName)_SQLServer:Buffer Manager_Single Instance_Buffer cache hit ratio]) ,
				avg([$($ServerName)_Processor Information__Total_% Processor Time]),
				avg([$($ServerName)_SQLServer:Buffer Manager_Single Instance_Page life expectancy])
		from	PerfCounters_$($ServerName)
		group by substring(convert(varchar(10),[datetime],111),1,10)


	)
	select * from CTEPerfCounters_$($ServerName);"
	$Data = Invoke-Sqlcmd2 -Query $Query -Database SQLServerRepository	-ServerInstance r2d2
		
	Export-Xls 	 -InputObject $data  `
				-Path "C:\SQLBITS\PerformanceCounters\$($ServerName)_$($CurrentDateTime).xlsx" `
				-WorksheetName "General"
	
	#Store the name of the XLSX
	$XLSnames += "C:\SQLBITS\PerformanceCounters\$($ServerName)_$($CurrentDateTime).xlsx" 

	#Pega As colunas que não são DATE
	#Get The columns not DATE
	Get-SqlDatabase -dbname SQLServerRepository -sqlserver $env:COMPUTERNAME |`
	Get-SqlTable -name "PerfCounters_$($ServerName)" | 	Get-SqlColumn  | `
	
	Where-Object { $_.name -notlike '*Date*' } | % {
	
		$ColumnName =[string] ($_.name).substring(($_.name).length -20,20)
	
		#Query to Create info and chart to each column
		#[string] $Query = Get-Content C:\SQLBITSAutomation\Query2.sql
		$Query = "	select substring(convert(varchar(10),[datetime],111),1,10) + ' ' + '$($_)' as Date,
					avg($($_)) as Value 
					from PerfCounters_$($ServerName)
					group by substring(convert(varchar(10),[datetime],111),1,10) 
				"
		$Data = Invoke-Sqlcmd2 -Query $Query -Database SQLServerRepository	-ServerInstance r2d2
		Export-Xls 	 -InputObject $data  `
			-Path "C:\SQLBITS\PerformanceCounters\$($ServerName)_$($CurrentDateTime).xlsx" `
			-WorksheetName $ColumnName `
			-ChartType "xlColumnClustered"

	}
	
}
