﻿#Donwload the SQLPSX Module
#http://sqlpsx.codeplex.com/
#Import-module SQLSERVER
#Import-module Functions
#Region Troubleshooting_4_DiskSpace

#################### APPROACH TO TROUBLESHOOTING
#################### We need to quickly check out the disk space

#I Can use Performance Counter. something Quickly
get-counter -computername (Get-Content "C:\SQLBITS\servers.txt" ) `
			-counter "\LogicalDisk(*)\% Free Space" `
| select -ExpandProperty COunterSamples

#Posso usar XP_FixedDrives. Mas se eu tiver Mount Points Já era
#I can use XP_FixedDrives, but it not display mount points

#Função Original do Aaron Nelson (@sqlvariant).
#Original Function from Aaron Nelson (@sqlvariant)

get-diskspace  -servername QuiGonJinn
get-diskspace -servername (Get-Content C:\SQLBITS\Servers.txt)
Get-Content C:\SQLBITS\Servers.txt | get-diskspace
"QuiGonJinn","obiwan" | get-diskspace

#Ha mas eu tenho uma tabela que tem os nomes dos servidores:
#I have a SQL ServerTable with the Servers Name
Invoke-Sqlcmd2 	-Query "Select ServerName from tbl_ServerNames" `
				-Database "SQLServerRepository" -ServerInstance r2d2 | 
get-diskspace 


#################### APPROACH TO CHECKLIST
#Tenho Um CheckLlist e gostaria de colocar esta verificação e me enviar por email no excel 
#I have a checklist and I want to output to a csv and send by email

Invoke-Sqlcmd2 	-Query "Select ServerName from tbl_ServerNames" `
				-Database "SQLServerRepository" -ServerInstance r2d2 `
				| get-diskspace | Export-Csv "C:\SQLBITS\DiskSpace\DiskSpace_$($CurrentDateTime).csv" `
											-NoTypeInformation -Force 


#Guardar Numa Tabela para ter historico de Crescimento
#save to a SQL Server table - historical growth - Capacity Plann 

(	Get-DiskSpace -servername (Get-Content "C:\SQLBITS\Servers.txt")`
	| 	select 	@{Expression= {(Get-Date -Format "yyyy-MM-dd hh:mm:ss") };Label = "Date"},`
				SystemName,`
				Name,`
				SizeInGB,`
				FreeInGB,`
				PercentFree,`
				Label 
 ) |  Out-DataTable | Write-DataTable 	-ServerInstance R2D2 `
										-Database SQLServerRepository `
										-TableName tbl_DiskSpace 

#Ha Laerte, mas eu tenho um mol (6,02 x 10(23)) de servidores pra administrar. 
#Quero somente os que tem percentual de espaço em disco menor que 10%. OK
#Somente adicionamos um where (trocar o where pelo espaço corrente)


#Asynchronous Mode #using Poshcode Split-Job

Get-Content C:\SQLBITS\Servers2.txt `
| split-job { Get-DiskSpace } -InitializeScript {ipmo functions -DisableNameChecking -Force} 

#but worth ?
Measure-Command {
	Get-Content "C:\SQLBITS\Servers2.txt" | Get-DiskSpace 
}

Measure-Command {
	Get-Content C:\SQLBITS\Servers2.txt | split-job { Get-DiskSpace } -InitializeScript {ipmo functions -DisableNameChecking -Force}  -noprogress  
}
#
Get-Content C:\SQLBITS\Servers2.txt | split-job { % {
	(	Get-DiskSpace -Servername $_ `
		| 	select 	@{Expression= {(Get-Date -Format "yyyy-MM-dd hh:mm:ss") };Label = "Date"},`
					SystemName,`
					Name,`
					SizeInGB,`
					FreeInGB,`
					PercentFree,`
					Label 
	 ) |  Out-DataTable | Write-DataTable 	-ServerInstance R2D2 `
											-Database SQLServerRepository `
											-TableName tbl_DiskSpace 
}  } -InitializeScript {ipmo functions -DisableNameChecking -Force}  -noprogress 

#EndRegion Troubleshooting_4_DiskSpace
