﻿#Donwload the SQLPSX Module
#http://sqlpsx.codeplex.com/
#Import-module SQLSERVER
#Import-module Functions
$global:TimeStamp = Get-Date -Format "yyyyMMdd_hhmm"
$Error.Clear()
Get-Content c:\sqlbits\Servers.txt |
Split-job { 
	ForEach-Object { #B
		try {
			Get-SqlDatabase -sqlserver $_ | 
			#Where-Object {$_.name -match '(AdventureWorks2012|AdventureWorks2012_1)'}|
			#To show Rebuild
			#Where-Object {$_.name -eq 'AdventureWorks2012_3'}|
			Get-SqlTable | 
			Get-SqlIndex |
			foreach-object { 
				$IndexObject = $_
				$SQLInstanceName = $_.server
				$Database = $_.dbname
				$SQLTable = $_.table
				$SQLInstanceNameCSV =  $SQLInstanceName  -replace '\\','_'
				Get-SqlIndexFragmentation -index $IndexObject  | 
				ForEach-Object {
					$Message= $null
					$Output = $Null
					if (($_.AverageFragmentation -ge  1 -and $_.AverageFragmentation -le 30  -and $_.Pages -ge 0)) {
						$HashTable = @{
										'SQLServerInstance'=$($SQLInstanceName)
										'Database' = $($Database) 
										'SQLTable' = $($SQLTable) 
										'IndexName' = $($_.Index_name)
										'IndexFragmentation'=$($_.AverageFragmentation)
										'Operation' = 'Reorganize'}
							
						$Output = New-Object psobject -Property $HashTable
						
					} elseif  (($_.AverageFragmentation -gt 30 -and $_.Pages -ge 0)) {
						$HashTable = @{
										'SQLServerInstance'=$($SQLInstanceName)
										'Database' = $($Database) 
										'SQLTable' = $($SQLTable) 
										'IndexName' = $($_.Index_name)
										'IndexFragmentation'=$($_.AverageFragmentation)
										'Operation' = 'Rebuilld'}
								
						$Output = New-Object psobject -Property $HashTable
						
					}

					if ($Output) {
						$Output | 
						Select-Object 	SQLServerInstance,
										Database,
										SQLTable,
										IndexName,
										IndexFragmentation,
										Operation,
										Action,
										Time |
						Export-Csv -Path (Join-Path -Path c:\sqlbits\fragmentation -ChildPath "$($SQLInstanceNameCSV).csv") -NoTypeInformation -append
						#remove if the file is empty
						if( (Get-childitem (Join-Path -Path c:\sqlbits\fragmentation -ChildPath "$($SQLInstanceNameCSV).csv")).length -eq 0) {
							Remove-Item (Join-Path -Path c:\sqlbits\fragmentation -ChildPath "$($SQLInstanceNameCSV).csv") -Force -ErrorAction SilentlyContinue
						}
					}
				}

			}
		} catch {
			$ErrorMessage = "$(Get-date) $($Error[0])"
			Write-Error $ErrorMessage
		}

	}
} -InitializeScript {ipmo functions -DisableNameChecking -Force;ipmo SQLServer -Force }  




#Convert CSV Files to excel
Convert-CSVToExcel -inputfile (Get-ChildItem c:\SQLBITS\fragmentation\*.csv)		-output  "c:\SQLBITS\fragmentation\Fragmentation.xlsx"



